# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`genders`](#genders): Manage genders

### Defined types

* [`genders::node`](#gendersnode): Manage genders node

## Classes

### <a name="genders"></a>`genders`

Manage genders

#### Examples

##### 

```puppet
include genders
```

#### Parameters

The following parameters are available in the `genders` class:

* [`manage_repo`](#manage_repo)
* [`package_name`](#package_name)
* [`package_ensure`](#package_ensure)
* [`config_path`](#config_path)
* [`nodes`](#nodes)

##### <a name="manage_repo"></a>`manage_repo`

Data type: `Boolean`

Boolean that sets of repo for genders should be managed
Currently only impacts Red Hat based systems

Default value: ``true``

##### <a name="package_name"></a>`package_name`

Data type: `String`

Genders package name

Default value: `'genders'`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

Genders package ensure property

Default value: `'installed'`

##### <a name="config_path"></a>`config_path`

Data type: `Stdlib::Absolutepath`

Path to genders file

Default value: `'/etc/genders'`

##### <a name="nodes"></a>`nodes`

Data type: `Hash`

Hash used to define genders::node resources.

Default value: `{}`

## Defined types

### <a name="gendersnode"></a>`genders::node`

Manage genders node

#### Examples

##### Define nodes

```puppet
genders::node { 'compute01':
  attrs => ['compute','rack01'],
}
```

##### Define node with Hash attrs

```puppet
genders::node { 'compute01':
  attrs => { 'class' => 'compute', 'rack' => 'rack01' },
}
```

#### Parameters

The following parameters are available in the `genders::node` defined type:

* [`node`](#node)
* [`attrs`](#attrs)
* [`content`](#content)
* [`source`](#source)
* [`order`](#order)

##### <a name="node"></a>`node`

Data type: `Variant[Array[String], String]`

The node or nodes to define in genders file

Default value: `$name`

##### <a name="attrs"></a>`attrs`

Data type: `Variant[Array[String],Hash[String,String]]`

Array or Hash of attributes to define for a node

Default value: `[]`

##### <a name="content"></a>`content`

Data type: `Optional[String]`

Optional content to override module template

Default value: ``undef``

##### <a name="source"></a>`source`

Data type: `Optional[String]`

Optional Source to override module template

Default value: ``undef``

##### <a name="order"></a>`order`

Data type: `String`

Order in genders file for this node

Default value: `'50'`

